package ghotiModule;

use File::Copy;

#################################################################################
# Returns true if the date is more than the defined no of years ago.
# This is useful for filtering out people who are living, or are likely to
# be living.
sub gtXYearsAgo { # {{{1
    my $dateString = $_[0];
    my $noYearsAgo = $_[1];
    my $year = "";
    ($year) = $dateString =~ /(\d\d\d\d)\s*$/; 
    if ($year) {
        ($sec,$min,$hour,$mday,$mon,$currentYear,$wday,$yday,$isdist) = gmtime(time);
        $thresholdYear = $currentYear + 1900 - $noYearsAgo;
        if ( $year < $thresholdYear) { return (1); }
	else { return (0); }
        }
} #}}}1


#################################################################################
# Converts Legacy formatting codes to HTML.
sub convertNoteToHTML{ # {{{1
    my $string = $_[0];
            $string =~ s/
//g;
	    # if (($filename) = $string =~ /&/) {
	    $string =~ s/&/&amp;/g;
	    $string =~ s/</&lt;/g;
	    $string =~ s/>/&gt;/g;
	    $string =~ s//</g;
	    $string =~ s//>/g;
	    $myLen = length $string;
	    if ($myLen > 300) {print "\n\n-W- String Length ", $myLen  ," of ",$string,"\n";}
	    return($string);
} #}}}1

#################################################################################
# Converts Legacy file references between [[ and ]] to links in HTML.
sub convertRefsToHTML{ # {{{1
    my $string       = $_[0];   # the string containing the references.
    my $targetDir    = $_[1];
    my $bigPicRoot   = $_[2];   # the directory containing the large version of the pictures
    my $smallPicRoot = $_[3];   # the directory containing the small version of the pictures
    my $htmlRoot     = $_[4];  
    my $masterDir    = $_[5];



    	   #while ($string =~/<</) { 
	   #while ($string =~/\[\[/) { 
	    while ($string =~/\{/) { 
		$preMatchString = $`;
		#if ($' =~/\]\]/){
		#if ($' =~/\]\]/){
		if ($' =~/\}/){
		  $postMatchString = $';
		  $matchString = $`;

		  if ($matchString =~ /\.jpg$/){
		   foreach $root ($bigPicRoot,$smallPicRoot) {

                    if ( -e ( $targetDir."/".$root ."/" .$matchString)) {
			    #print "\tfound ".$targetDir."/".$root ."/" .$matchString ."\n";
        	       	}   # TODO masterDir is not found.
		    elsif (-e ($masterDir."/".$root ."/" .$matchString)) {
			    print "-I- Copying $matchString from $masterDir to $targetDir...";
			    copy ($masterDir."/".$root ."/" .$matchString,
				  $targetDir."/".$root ."/" .$matchString  );
			    print "..complete\n";
		    	}
		    else {
			print "-W- couldn't find ".$masterDir."/".$root ."/" .$matchString."\n";
		    	}
		    	}



		  # For jpg files, image small file, but link to large one.
	            $string = $preMatchString 
		            . "<a href=\"../"  . $bigPicRoot   . "/" . $matchString . "\">"
		            . "<img src=\"../" . $smallPicRoot . "/" . $matchString 
			    . "\" border=\"0\"></a>" 
			    . $postMatchString ;
	  	    }

		  # For html files, first word is link text.
		  elsif ($matchString =~ /\.html?#?\S*\s*$/){
	            ($linkText) = $matchString =~ /^(\S*)/;
		    ($fileName) = $matchString =~ /(\S*\.html?#?\S*)\s*$/;
	            $string = $preMatchString 
		            . "<a href=\"../"  . $htmlRoot   . "/" . $fileName . "\">"
		            . $linkText . "</a>" 
			    . $postMatchString;
	  	    }
		  else { print "\n-W- undefined   contents.. assumed private and removed:\n", 
			       "    ",$string, "\n";
			 $string = $preMatchString . $postMatchString; 
		       }
	  	  }
		else {
			print "-W-  without matching ...  deleted\n",
			       "    ",$string, "\n";
		      $string =~ s/\{//; 
		     }
		}

	    
	    return($string);
} #}}}1


#################################################################################
# Generate a string of current time and date with format 
# "12:15 Tue 25th Feb 2003"
sub dateString { # {{{1
($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdist) = gmtime(time);


@monthName = (qw(Jan Feb Mar apr
                 May Jun Jul aug
                 Sep Oct nov dec));

@dayOfMonthName = (qw( 1st  2nd  3rd  4th  5th  6th  7th  8th  9th 10th
                      11th 12th 13th 14th 15th 16th 17th 18th 19th 20th
                      21st 22nd 23rd 24th 25th 26th 27th 28th 29th 30th
                      31st  ) );

@dayOfWeekName = (qw(Sun Mon Tue Wed Thu Fri Sat));

if ($min <= 9) {$min = "0".$min} # if minute is a single digit convert to 2 char string.

$returnString = $hour . ":"
              . $min .  " "
              . $dayOfWeekName[$wday] . ", "
              . $dayOfMonthName[$mday-1] . " "
              . $monthName[$mon] . " "
              . ($year+1900); 
      return $returnString;

} #}}}1


#################################################################################
# Compare the contents of two directories and generate a delta.
# TODO not yet implemented
sub cmpDirAndGenDelta { # {{{1
opendir DH, ".";
@list = readdir DH;
print @list;
for ($k=0; $k<$#list; $k++) {
print $list[$k],"\n";
}
closedir DH;

print "-E- ERROR Function not yet implimented"; # TODO

## TODO list added files
## TODO list deleted files
## compare other files, excluding the lastupdate string.
##  if the files are the same, do nothing.
##  if one doesn't exist already, create an empty delta directory.
##  if the files are different, copy the new file to the delta directory.


} #}}}1


#################################################################################
# return 1 if the files are different, (ignoring the last update 
# information ONLY)
# TODO not yet implemented
sub compareData { # {{{1
my $file1 = $_[0];
my $file2 = $_[1];

print "Funtion not yet implimented"; # TODO

} #}}}1


#################################################################################
# Constructs a sentance which is a list. TYpically used to construct sentances
# such as "6 Boys, 1 Girl and 2 children of unknown gender"
sub sentanceList { # {{{1
	my $aCount    = $_[0];
	my $aSingular = $_[1];
	my $aPlural   = $_[2];
	my $bCount    = $_[3];
	my $bSingular = $_[4];
	my $bPlural   = $_[5];
	my $cCount    = $_[6];
	my $cSingular = $_[7];
	my $cPlural   = $_[8];
	
	my $totalCount;
	$totalCount = $aCount + $bCount + $cCount;

	if ( $totalCount == 0 ) { print "***ERROR - sentanceList called with no items to list\n" }

	$returnString = " ";

	if ( $aCount == 1 ) {$returnString .= $aCount ." ". $aSingular}
	if ( $aCount > 1 ) {$returnString .= $aCount ." ". $aPlural}
	if ( $aCount >0 and ($bCount+$cCount)>0) {
		if ($bCount>0 and $cCount>0){ $returnString .= ", " }
		else { $returnString .= " and "}
		}

        	
	if ( $bCount == 1 ) {$returnString .= $bCount ." ". $bSingular}
	if ( $bCount > 1 ) {$returnString .= $bCount ." ". $bPlural}
	if ( $bCount >0 and ($cCount)>0) {$returnString .= " and "}

	if ( $cCount == 1 ) {$returnString .= $cCount ." ". $cSingular}
	if ( $cCount > 1 ) {$returnString .= $cCount ." ". $cPlural}
	return ($returnString);
	
} #}}}1


#################################################################################
# output a . every Nth time it is called. Usefull to indicate program activity.
sub progressIndicator { # {{{1
	my $counter    = $_[0];
	$counter++;
	print "\r",$counter;
        return ($counter);
} #}}}1

#################################################################################
sub checkLinks { # {{{1

# This is a bit of a sledge hammer approach, and the result should be filtered.
# Basically every contents file is inspected for links, and then links to those 
# file are examined to see if they exist. Consequenty, if there is more than one 
# link from a contents file to a family file, then the family file is checked 
# more than once.
#
# Due to the nature of the data, this is a common occurance, but the intention is 
# to carry an exhaustive search for broken links, rather than an efficient one!

my $rootDir    = $_[0]."/";
my $contentsFile    = $_[1];
my $reportFileHandle = $_[2];

my $failCount = 0;

$htmlfile = $rootDir.$contentsFile;

open (REPORTFILE,">>".$reportFileHandle);

unless (open (FH,"<".$htmlfile)) {
	  print "\nERROR - unable to open " . $htmlfile . " for reading\n";
          return (1);
	}

$indexLineRef = 0;
	
while ($line=<FH>) {

  $indexLineRef = $indexLineRef + 1;
  chop $line;
  $restOfLine = $line;

  getNextLink: while ($restOfLine =~ /\w*\.html\w*/){
     ($link) = ($restOfLine =~ /\w*\"(\S*\.html)/);
     $restOfLine = $';
     if ( -e ($rootDir.$link) and $link ne "") {  # -e = if doesn't exist
# {{{2
        #print "found ", $rootDir.$link, "\n";
        unless (open (FAM,"<".$rootDir.$link)) {
        	  die "\nERROR - unable to open " . $rootDir.$link . " for reading - line ",indexLineRef;
        	}
	$iin++ ;
	#print "\r",$iin;
        while ($subLine=<FAM>) {

            chop $subLine;
            $restOfSubLine = $subLine;

            while ($restOfSubLine =~ /\w*\.(html|jpg)\w*/){
                ($subLink) = ($restOfSubLine =~ /\w*\"(\S*\.(html|jpg))/);
                $restOfSubLine = $';
             if ( -e ($rootDir."families/".$subLink) ) {  # -e = if exists
		    }
             else { $message = "broken link ".$subLink. " \tin ". $rootDir.$link;
  		    if ($message ne "") {
     			foreach $l (@messageList) {
	  			if ($message eq $l) { next getNextLink; }
	  			} 
    			push @messageList,$message; 
    			} 
		    $failCount++;
   		    print REPORTFILE "broken link ",$subLink, " \tin ", $rootDir.$link, "\n";
		    }
    
                }
            }
        close FAM; # }}}2
        }
  else  {
	if ($link ne "") {  print "\nERROR file ".$rootDir.$link." not found"; $failCount++; }
        #die "ERROR file ".$rootDir.$link." not found\n";
	}
     }


  }
   close REPORTFILE;
  return ($failCount);
} #}}}1

#################################################################################
sub examineLinkReport { # {{{1
# This is intended as a post process or for the checkLinks process. It reads the 
# file produced by CheckLinks, extracts a list of targets for links which were 
# broken, and prints this list summary. Each missing link is listed once, no matter 
# how many times it occurs in the html hierarchy.

my $reportFileHandle = $_[0];

my $failCount = 0;

$htmlfile = $rootDir.$contentsFile;

open (REPORTFILE,"<".$reportFileHandle);

getNextLine: while ($line=<REPORTFILE>) {

chop $line;

if ($line ne "") {
    foreach $l (@linkList) {
	  if ($line eq $l) { next getNextLine; }
	  } 
    push @linkList,$line; 
    }
  }
close REPORTFILE;

# Print summary
foreach $l ( sort @linkList ) {
	print $l,"\n";
        }
return;

} #}}}1


#################################################################################
sub getHTML { # {{{1

    my $fileHandle = $_[0];
    my $terminator = $_[1];
    my $localDateString = ghotiModule::dateString; 
    my $returnString = "";
    while ($line=<$fileHandle>){ 
	    if ($line =~ /\s*$terminator\s*/){
            	$returnString =~ s/
//g;
            	$returnString =~ s/ghotiModule::dateString/$localDateString/g;
		return ($returnString);
		}
	    else {$returnString = $returnString.$line;}
	   } 
} #}}}1

1;

__END__
